@echo off

setlocal 

REM ==================================================================================
if DEFINED JAVA_HOME goto setj2seroot
REM set your JAVA_HOME variable to state which jdk you will use to compile the launcher
Set JAVA_HOME=C:\Program Files\Java\jdk1.8.0_111
if EXIST  "%JAVA_HOME%" goto setj2seroot
Echo no JDK present on this server - please set it in this script
goto end


:setj2seroot
REM XSTUDIO_J2SE_ROOT indicates which jdk to use for compilation
SET XSTUDIO_J2SE_ROOT=%JAVA_HOME%

REM XSTUDIO_LAUNCHER_NAME indicates the name of the launcher being compiled
SET XSTUDIO_LAUNCHER_NAME=%~1

REM XSTUDIO_SOURCE_FILES indicates which source files to compile
SET XSTUDIO_SOURCE_FILES=../src/com/xqual/xlauncher/CTimeoutListener.java ../src/com/xqual/xlauncher/CLauncherCommonParsers.java ../src/com/xqual/xlauncher/CClientDownloader.java "../src/com/xqual/xlauncher/%XSTUDIO_LAUNCHER_NAME%/CLauncherImpl.java"

if "%~1"=="proxy" SET XSTUDIO_SOURCE_FILES= "../src/com/xqual/xlauncher/%XSTUDIO_LAUNCHER_NAME%/IRemoteSubAgent.java" "../src/com/xqual/xlauncher/%XSTUDIO_LAUNCHER_NAME%/CLauncherImpl.java"
rem echo %XSTUDIO_SOURCE_FILES%

REM XSTUDIO_MAIN_CLASS indicates the classpath of the mainclass
SET XSTUDIO_MAIN_CLASS=com.xqual.xlauncher.%XSTUDIO_LAUNCHER_NAME%.CLauncherImpl

REM XSTUDIO_TEMP_FOLDER indicates the location where the class files will be created
SET XSTUDIO_TEMP_FOLDER=../classes

REM XSTUDIO_OUTPUT_FOLDER indicates the location where the jar file will be created
SET XSTUDIO_OUTPUT_FOLDER=../bin
REM ==================================================================================



SET XSTUDIO_LAUNCHER_LIB=../lib/launcher_lib.jar
if exist %XSTUDIO_LAUNCHER_LIB% goto json
   echo %XSTUDIO_LAUNCHER_LIB% does not exist ! please, edit this file and specify the library location.
   echo You may need to reinstall xstudio taking care of selecting libraries in the list of components to install.
   goto end

:json
SET JSON_LIB=../lib/json-20171018/json-20171018.jar

:freechart   
SET JFREECHART_LIBS=../lib/jfreechart-1.0.10/lib/jcommon-1.0.13.jar;../lib/jfreechart-1.0.10/lib/jfreechart-1.0.10.jar
   
:xmlrpc   
SET XML_RPC_LIBS=../lib/apache-xmlrpc-3.1.3/lib/commons-logging-1.1.jar;../lib/apache-xmlrpc-3.1.3/lib/ws-commons-util-1.0.2.jar;../lib/apache-xmlrpc-3.1.3/lib/xmlrpc-client-3.1.3.jar;../lib/apache-xmlrpc-3.1.3/lib/xmlrpc-common-3.1.3.jar;../lib/apache-xmlrpc-3.1.3/lib/xmlrpc-server-3.1.3.jar
   

:bin
If exist "../bin/." goto compile
mkdir "../bin"


:compile

echo preparing environment...
mkdir "%XSTUDIO_TEMP_FOLDER%"
if exist "%XSTUDIO_OUTPUT_FOLDER%/%XSTUDIO_LAUNCHER_NAME%.jar" del "%XSTUDIO_OUTPUT_FOLDER%/%XSTUDIO_LAUNCHER_NAME%.jar"

echo compiling source code...
"%XSTUDIO_J2SE_ROOT%/bin/javac" -deprecation -d %XSTUDIO_TEMP_FOLDER% -classpath %XSTUDIO_LAUNCHER_LIB%;%JSON_LIB%;%JFREECHART_LIBS%;%XML_RPC_LIBS% %XSTUDIO_SOURCE_FILES%

If %ERRORLEVEL% == 0 goto manifest
Echo compilation got errors - please correct
if exist %1.txt del %1.txt
Echo %1 >>%1.txt
goto end

:manifest
echo generating Manifest...
echo Manifest-Version: 1.0> MANIFEST.MF
echo Ant-Version: Apache Ant 1.6.5>> MANIFEST.MF
echo Created-By: 1.6.0_02-b06 (Sun Microsystems Inc.)>> MANIFEST.MF
echo Main-Class: %XSTUDIO_MAIN_CLASS%>> MANIFEST.MF
type MANIFEST.MF

echo packaging classes files in a JAR archive...
"%XSTUDIO_J2SE_ROOT%/bin/jar" cmf MANIFEST.MF %XSTUDIO_OUTPUT_FOLDER%/%XSTUDIO_LAUNCHER_NAME%.jar -C %XSTUDIO_TEMP_FOLDER% .


echo Copying configuration XML to ../bin
Copy ..\src\com\xqual\xlauncher\%XSTUDIO_LAUNCHER_NAME%\%1.xml ..\bin\%1.xml

echo cleaning up...
rmdir /S /Q "%XSTUDIO_TEMP_FOLDER%"
del /F /Q MANIFEST.MF

echo terminated.

:end