#!/bin/bash


#==================================================================================


# XSTUDIO_LAUNCHER_NAME indicates the name of the launcher being compiled
export XSTUDIO_LAUNCHER_NAME=shell

# XSTUDIO_SOURCE_FILES indicates which source files to compile
XSTUDIO_SOURCE_FILES="../src/com/xqual/xlauncher/CTimeoutListener.java ../src/com/xqual/xlauncher/$XSTUDIO_LAUNCHER_NAME/CLauncherImpl.java"
export XSTUDIO_SOURCE_FILES


# XSTUDIO_MAIN_CLASS indicates the classpath of the mainclass
export XSTUDIO_MAIN_CLASS=com.xqual.xlauncher.$XSTUDIO_LAUNCHER_NAME.CLauncherImpl

# XSTUDIO_TEMP_FOLDER indicates the location where the class files will be created
export XSTUDIO_TEMP_FOLDER=../classes

# XSTUDIO_OUTPUT_FOLDER indicates the location where the jar file will be created
export XSTUDIO_OUTPUT_FOLDER=../bin
# ==================================================================================




#checklib

export XSTUDIO_LAUNCHER_LIB=../lib/launcher_lib.jar

if [ -z ${XSTUDIO_LAUNCHER_LIB} ]
then
 	echo "$XSTUDIO_LAUNCHER_LIB does not exist ! please, edit this file and specify the library location."
	echo "You may need to reinstall xstudio taking care of selecting libraries in the list of components to install."
	exit 1
fi

#compile

echo preparing environment...
mkdir "$XSTUDIO_TEMP_FOLDER"
if [ -f "$XSTUDIO_OUTPUT_FOLDER/$XSTUDIO_LAUNCHER_NAME.jar" ] 
then 
	rm "$XSTUDIO_OUTPUT_FOLDER/$XSTUDIO_LAUNCHER_NAME.jar"
fi



echo compiling source code...
javac -deprecation -d $XSTUDIO_TEMP_FOLDER -classpath $XSTUDIO_LAUNCHER_LIB $XSTUDIO_SOURCE_FILES



echo generating Manifest...
echo Manifest-Version: 1.0> MANIFEST.MF
echo Ant-Version: Apache Ant 1.6.5>> MANIFEST.MF
echo Created-By: 1.6.0_02-b06 Sun Microsystems Inc.>> MANIFEST.MF
echo Main-Class: $XSTUDIO_MAIN_CLASS>> MANIFEST.MF

echo packaging classes files in a JAR archive...
jar cmf MANIFEST.MF $XSTUDIO_OUTPUT_FOLDER/$XSTUDIO_LAUNCHER_NAME.jar -C $XSTUDIO_TEMP_FOLDER .

echo cleaning up...
rmdir --ignore-fail-on-non-empty "$XSTUDIO_TEMP_FOLDER"
rm  MANIFEST.MF

echo terminated.

