package com.xqual.xlauncher;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Vector;

public class CHttpDownloader {

	// +==============================================================+
	// | Members                                                      |
	// +==============================================================+

	static final String TRACE_HEADER = "    {http download }  ";

	// +==============================================================+
	// | Constructors                                                 |
	// +==============================================================+

	public CHttpDownloader() {
	}

	// +==============================================================+
	// | Methods                                                      |
	// +==============================================================+

	public Vector<String> getReleaseNumbers(String url) {
		int count = 0;
		Vector<String> outputVector = new Vector<String>();
		try {
			HttpURLConnection httpConnection = (HttpURLConnection) new URL(url).openConnection();
			InputStream is = httpConnection.getInputStream();
			BufferedReader in = new BufferedReader(new InputStreamReader(is));

			String fromServer;
			StringBuffer inputBuffer = null;

			inputBuffer= new StringBuffer();
			while ((fromServer = in.readLine()) != null) { // receive
				if (fromServer.indexOf("<a href=\"") >= 0) {
					int indexStart = fromServer.indexOf("<tt>");
					if (indexStart > 0) {
						int indexStop = fromServer.indexOf("</tt>");
						String releaseNumber = fromServer.substring(indexStart+4, indexStop-1);
						try {
							outputVector.add(releaseNumber);
							System.out.println(TRACE_HEADER + "release: " + releaseNumber);
							count++;
						} catch (NumberFormatException e) {
							//System.out.println("NumberFormatException");
						}
					}
				}
				inputBuffer.append(fromServer);
			}

			is.close();
			in.close();
		} catch (IOException e) {
			System.out.println("IOException");
		}
		System.out.println(TRACE_HEADER + "nb releases: " + count);
		return outputVector;
	}


	public boolean downloadFile(File outputFile, String url) {
		int count = 0;
		try {
			HttpURLConnection httpConnection = (HttpURLConnection) new URL(url).openConnection();
			InputStream is = httpConnection.getInputStream();
			FileOutputStream fos = new FileOutputStream(outputFile);

			int oneChar;
			while ((oneChar = is.read()) != -1) {
				if (count > 0) {
					if (count%(100*1024) == 0)    // every 100K
						System.out.print("#");
					if (count%(100*100*1024) == 0) // every 10M
						System.out.print("\n");
				}
				fos.write(oneChar);
				count++;
			}
			is.close();
			fos.close();
		} catch (Exception e) {
			System.out.println(TRACE_HEADER + "error reading the file: " + e);
			return false;
		}
		System.out.print("\n");
		System.out.println(TRACE_HEADER + "nb bytes written: " + count);
		return true;
	}
}
