package com.xqual.xlauncher;

import java.io.File;
import java.util.Vector;

import com.xqual.xcommon.utils.CFileUtils;

public class CSharedFolderDownloader {

	// +==============================================================+
	// | Members                                                      |
	// +==============================================================+

	static final String TRACE_HEADER = "    {share download}  ";

	// +==============================================================+
	// | Constructors                                                 |
	// +==============================================================+

	public CSharedFolderDownloader() {
	}

	// +==============================================================+
	// | Methods                                                      |
	// +==============================================================+

	public Vector<Integer> getReleaseNumbers(String url) {
		int count = 0;
		Vector<Integer> outputVector = new Vector<Integer>();
		File parentFolder = new File(url);

		File[] revisionFolders = parentFolder.listFiles();
		for (int i=0; i<revisionFolders.length; i++) {
			String releaseNumber = revisionFolders[i].getName();
			try {
				Integer intRelease = new Integer(releaseNumber);
				// if we come here then it means that the folder exists but maybe the build is not yet finished...
				// we test this by checking the presence of build.log
				if (new File(url + "/" + releaseNumber + "/win32/build.log").exists()) {
					outputVector.add(intRelease);
					System.out.println(TRACE_HEADER + "available release: " + releaseNumber);
					count++;
				} else {
					System.out.println(TRACE_HEADER + "not yet finished release: " + releaseNumber);
				}
			} catch (NumberFormatException e) {
				//System.out.println("NumberFormatException");
			}
		}

		System.out.println(TRACE_HEADER + "nb releases: " + count);
		return outputVector;
	}


	public boolean downloadFile(File outputFile, String url, boolean trace) {
		System.out.println(TRACE_HEADER + "trying to download " + url + "...");
		return CFileUtils.copyFileToFile(new File(url), outputFile, trace);
	}
}
