/*
+----------------------------------------------------------------------+
|                    Class: CLauncherRestBackend                       |
|                                                                      |
| Developper:  Eric Gavaldo (eric.gavaldo@xqual.com)                   |
+----------------------------------------------------------------------+
*/
package com.xqual.xlauncher.gitlab_ci_cd;

import com.xqual.xcommon.IConstantsResults;

public class CLauncherRestBackend implements IConstantsResults {

	// +==============================================================+
	// | Attributes                                                   |
	// +==============================================================+

	public CLauncherRestConnectionManager connectionManager;
    
	// +==============================================================+
	// | Constructors                                                 |
	// +==============================================================+
    
	public CLauncherRestBackend(CLauncherRestConnectionManager connectionManager) {
		this.connectionManager = connectionManager;
	}
	
	// +==============================================================+
	// | GET Methods                                                  |
	// +==============================================================+
	
	public String startPipeline(String formData) {
   		System.out.println(">>>>>> [REST/POST] startPipeline(" + formData + ")");
		
		String jsonContent = performPostQuery(formData);
		return jsonContent;
	}
	
	
	// +==============================================================+
	// | POST Methods                                                 |
	// +==============================================================+

   	private String performPostQuery(String formData) {
    	try {
	    	String jsonContent = connectionManager.postData(formData);
	    	
	    	if (jsonContent == null) { // return code != 200
	    		System.err.println(">>>>>> [REST/POST] Failure!");
	    		return null;
	    	} else {
	    		System.out.println(">>>>>> [REST/POST] success: " + jsonContent);
	    	}
	    	
	    	return jsonContent;
    	} catch (Exception e) {
			System.err.println(">>>>>> [REST/POST] Exception: " + e);
			return null;
		}
   	}
}

