/*
+----------------------------------------------------------------------+
|                    Class: IXmlRpcLauncher                            |
|                                                                      |
| Developper:  Eric Gavaldo (eric.gavaldo@xqual.com)                   |
+----------------------------------------------------------------------+
*/
package com.xqual.xlauncher.proxy;

import org.w3c.dom.Node;

/**
 * The <code>IXmlRpcLauncher</code> class defines teh interface to be implemented by the proxied agent
 * @author egavaldo
 */
public interface IRemoteSubAgent {

	// additional methods
	public int  instanciateLauncher(String launcherName, String configurationName);
	public int  freeLauncher();
	public Node getExecutionSteps();

	// methods mapped on the standard ILauncher interface
	public int initialize(int sutId, String sutName, String sutVersion);
	public int preRun(int testId, String testPath, String testName, Object[] attributes, String additionalInfo);
	public int run(int testId, String testPath, String testName, int testcaseId, int testcaseIndex, String testcaseName, Object[] params, String additionalInfo);
	public int postRun(int testId, String testPath, String testName);
	public int terminate();
	
	/*
	public void setTestBooleanCustomFieldsHashtable(Hashtable<Integer, Vector<CNameAndValueDescriptor>> testBooleanCustomFieldsHashtable);
	public void setTestIntegerCustomFieldsHashtable(Hashtable<Integer, Vector<CNameAndValueDescriptor>> testIntegerCustomFieldsHashtable);
	public void setTestStringCustomFieldsHashtable(Hashtable<Integer, Vector<CNameAndValueDescriptor>> testStringCustomFieldsHashtable);
	public void setTestHtmlCustomFieldsHashtable(Hashtable<Integer, Vector<CNameAndValueDescriptor>> testHtmlCustomFieldsHashtable);
	public void setTestStringChoiceCustomFieldsHashtable(Hashtable<Integer, Vector<CNameAndValueDescriptor>> testStringChoiceCustomFieldsHashtable);
	
	public void setTestcaseBooleanCustomFieldsHashtable(Hashtable<Integer, Vector<CNameAndValueDescriptor>> testcaseBooleanCustomFieldsHashtable);
	public void setTestcaseIntegerCustomFieldsHashtable(Hashtable<Integer, Vector<CNameAndValueDescriptor>> testcaseIntegerCustomFieldsHashtable);
	public void setTestcaseStringCustomFieldsHashtable(Hashtable<Integer, Vector<CNameAndValueDescriptor>> testcaseStringCustomFieldsHashtable);
	public void setTestcaseHtmlCustomFieldsHashtable(Hashtable<Integer, Vector<CNameAndValueDescriptor>> testcaseHtmlCustomFieldsHashtable);
	public void setTestcaseStringChoiceCustomFieldsHashtable(Hashtable<Integer, Vector<CNameAndValueDescriptor>> testcaseStringChoiceCustomFieldsHashtable);
	
	public void setSutBooleanCustomFieldsVector(Vector<CNameAndValueDescriptor> sutBooleanCustomFieldsVector);
	public void setSutIntegerCustomFieldsVector(Vector<CNameAndValueDescriptor> sutIntegerCustomFieldsVector);
	public void setSutStringCustomFieldsVector(Vector<CNameAndValueDescriptor> sutStringCustomFieldsVector);
	public void setSutHtmlCustomFieldsVector(Vector<CNameAndValueDescriptor> sutHtmlCustomFieldsVector);
	public void setSutStringChoiceCustomFieldsVector(Vector<CNameAndValueDescriptor> sutStringChoiceCustomFieldsVector);
	*/	
}
